HDU - 3480 P - Division [ 斜率 ]

Problem Destribe

Little D is really interested in the theorem of sets recently. There’s a problem that confused him a long time.
Let T be a set of integers. Let the MIN be the minimum integer in T and MAX be the maximum, then the cost of set T if defined as (MAX – MIN)^2. Now given an integer set S, we want to find out M subsets S1, S2, …, SM of S, such that
在这里插入图片描述
and the total cost of each subset is minimal.

Input

The input contains multiple test cases.
In the first line of the input there’s an integer T which is the number of test cases. Then the description of T test cases will be given.
For any test case, the first line contains two integers N (≤ 10,000) and M (≤ 5,000). N is the number of elements in S (may be duplicated). M is the number of subsets that we want to get. In the next line, there will be N integers giving set S.

Output

For each test case, output one line containing exactly one integer, the minimal total cost. Take a look at the sample output for format.

Sample Input

2
3 2
1 2 4
4 2
4 7 10 1

Sample Output

Case 1: 1
Case 2: 18

Hint

The answer will fit into a 32-bit signed integer.

题意 : 把n个数字 分成m个集合。 每个集合的价值是 这个集合中 (max-min)^2。 输出最

少的价值

思路 : 我们可以使用 dp[i][j] 代表 以 j 结尾 第 j 个集合的最小值

那么可以容易的推出来 dp[i][j] = min { dp[k][j-1] + ( v[j] - v[k] ) * ( v[j] - v[k] ) } ;

但是这个算法的时间复杂度是 O( n^3 ) 很容易 TLE ,因此我们需要用到斜率进行优化 ,

其实这个题几乎是斜率优化的裸题了,没学过的可以学习一下

AC code :

#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

typedef long long ll;

const int maxn = 1e4+50;
const int maxm = 5e3+50;

ll dp[maxn][maxm] ,v[maxn] ;
int n ,m ;
int que[maxn] ,head ,tail ;

ll getdp(int i,int j,int k) {
	return dp[k][j-1] + (v[i] - v[k + 1]) * (v[i] - v[k + 1]);
}

ll y(int j,int k,int q) {
	return dp[k][j-1] + v[k + 1] * v[k + 1] - (dp[q][j-1] + v[q + 1] * v[q + 1]);
}

ll x(int k,int q) {
	return 2 * ( v[k + 1] - v[q + 1] );
}

int main() {
	int t ,ncase = 1 ; cin>>t;
	while(t--) {
		scanf("%d %d",&n ,&m );
		for (int i = 1;i<=n;i++) scanf("%lld",&v[i] );
		sort(v + 1 ,v + n + 1 );
		for (int i = 1;i<=n;i++) dp[i][1] = (v[i] - v[1]) * (v[i] - v[1]);
		for (int i = 2;i<=m;i++) {
			head = tail = 0; que[tail ++] = i - 1;
			for (int j = i;j<=n;j++) {
				while(head + 1 < tail && y(i ,que[head+1] ,que[head]) < x(que[head+1] ,que[head]) * v[j] ) head ++;
				dp[j][i] = getdp(j ,i ,que[head] );
				while(head + 1 < tail && y(i ,que[tail-1] ,que[tail-2]) * x(j ,que[tail-1]) >= y(i ,j ,que[tail-1]) * x(que[tail-1] ,que[tail-2]) ) tail --;
				que[tail ++] = j;
			}
		}
		printf("Case %d: ",ncase++);
		printf("%lld\n",dp[n][m]);
	}
	return 0;
}

### 关于HDU - 6609 的题目解析 由于当前未提供具体关于 HDU - 6609 题目的详细描述,以下是基于一般算法竞赛题型可能涉及的内容进行推测和解答。 #### 可能的题目背景 假设该题目属于动态规划类问题(类似于多重背包问题),其核心在于优化资源分配或路径选择。此类问题通常会给出一组物品及其属性(如重量、价值等)以及约束条件(如容量限制)。目标是最优地选取某些物品使得满足特定的目标函数[^2]。 #### 动态转移方程设计 如果此题确实是一个变种的背包问题,则可以采用如下状态定义方法: 设 `dp[i][j]` 表示前 i 种物品,在某种条件下达到 j 值时的最大收益或者最小代价。对于每一种新加入考虑范围内的物体 k ,更新规则可能是这样的形式: ```python for i in range(n): for s in range(V, w[k]-1, -1): dp[s] = max(dp[s], dp[s-w[k]] + v[k]) ``` 这里需要注意边界情况处理以及初始化设置合理值来保证计算准确性。 另外还有一种可能性就是它涉及到组合数学方面知识或者是图论最短路等相关知识点。如果是后者的话那么就需要构建相应的邻接表表示图形结构并通过Dijkstra/Bellman-Ford/Floyd-Warshall等经典算法求解两点间距离等问题了[^4]。 最后按照输出格式要求打印结果字符串"Case #X: Y"[^3]。 #### 示例代码片段 下面展示了一个简单的伪代码框架用于解决上述提到类型的DP问题: ```python def solve(): t=int(input()) res=[] cas=1 while(t>0): n,k=list(map(int,input().split())) # Initialize your data structures here ans=find_min_unhappiness() # Implement function find_min_unhappiness() res.append(f'Case #{cas}: {round(ans)}') cas+=1 t-=1 print("\n".join(res)) solve() ```
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值